#include <stdio.h>
#include <string.h>

int usage();
int main(int argc,char *argv[]) {
  char fname[1024];
  char rrname[1024];
  char auto_prefix[1024];
  int i,j;
  int n;
  int s,t;
  FILE *fp;
  strcpy(auto_prefix,"auto");
  s=t=0;
  for (i=1; i<argc; i++) {
    if(strcmp(argv[i],"--s")==0) {
      i++; sscanf(argv[i],"%d",&s);
    }else if (strcmp(argv[i],"--t")==0) {
      i++; sscanf(argv[i],"%d",&t);
    }else if (strcmp(argv[i],"--auto_prefix")==0) {
      i++; strcpy(auto_prefix,argv[i]);
    }
  }
  if (s*t == 0) {usage(); return(-1);}
  if (s>t) { usage(); return(-1);}
  n=s;
  sprintf(fname,"tmp-Hkn-%s-%dx%d",auto_prefix,s,t);
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      sprintf(rrname,"tmp-gen-ab-%d-%d.tmp.rr",i,j);
      fp = fopen(rrname,"w");
      fprintf(fp,"import(\"a27d-init.rr\")$\n");
      fprintf(fp,"load(\"%s-%d-%d.rr\")$\n",fname,i,j);
      fprintf(fp,"H_%d_%d=myltov(H_%d_%d)$\n",i,j,i,j);
      fprintf(fp,"bsave(H_%d_%d,\"%s-%d-%d.rr.ab\")$\nquit();\n",i,j,fname,i,j);
      fclose(fp);
      printf("openxm asir <%s\n",rrname);
      printf("echo Done %d-%d\n",i,j);
    }
  }
  printf("rm tmp-gen-ab-*.tmp.rr\n");
  return(0);
}

int usage() {
  fprintf(stderr,"usage: gen-ab --s sval --t tval [--auto_prefix xyz] >tt.sh ; sh ./tt.sh\n");
  fprintf(stderr,"  sval <= tval,  sval and tval stand for auto_ppp(sval,tval)\n");
  return(0);
}
